//SpiraleVariable_501f.js
// 08.01.14 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Dessine une spirale

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// tester s'il y a un document ouvert
if (app.documents.length == 0) {
	alert ("Il n'y a pas de document ouvert.", "Attention");
	exit();
}

// tester, s'il y a un objet slectionn
if (app.selection.length == 0) {
	alert ("Slectionner un bloc, s.v.p.", "Attention");
	exit();
}

// le document au premier plan
var curDoc = app.documents[0];

// mmoriser les units de mesure, l'origine des rgles, les points zro et de rfrence
hM = curDoc.viewPreferences.horizontalMeasurementUnits;
vM = curDoc.viewPreferences.verticalMeasurementUnits;
rO = curDoc.viewPreferences.rulerOrigin;
zP = curDoc.zeroPoint;
tR = curDoc.layoutWindows[0].transformReferencePoint;

// modifier les rglages
curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
curDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
curDoc.viewPreferences.rulerOrigin = RulerOrigin.SPREAD_ORIGIN;
curDoc.zeroPoint = [0,0];
curDoc.layoutWindows[0].transformReferencePoint = AnchorPoint.topLeftAnchor;

// mmoriser la dimension de la slection
try {
	var gB = app.selection[0].geometricBounds;
}
catch (e) {
	alert ("Il faudrait slectionner un bloc rectangulaire.", "Stop");
	reStoreSettings();
	exit();
}

// appeler la fonction qui lit les prfrences mmorises
var allPrefs = getPrefs();
ck01 = ck02 = 0;
if (allPrefs != "") {
	var prefVal = allPrefs.split("\n");
	strW = prefVal[0]*1;
	strT = prefVal[1]*1;
	dtV1 = prefVal[2]*1;
	dtV2 = prefVal[3]*1;
	numV = prefVal[4]*1;
	delV = prefVal[5]*1;
	rb01 = prefVal[6]*1;
	if (rb01 == 0) {
		ck01 = 1;
	}
	else {
		ck02 = 1;
	}
}
else {
	// sinon utiliser les valeurs par dfaut 
	// quand le fichier des prfrences n'existe pas
	strW = 1;
	strT = 100;
	dtV1 = 20;
	dtV2 = 5;
	numV = 15;
	delV = 0;
	ck01 = 1;
	ck02 = 0;
}

// appeler la fonction qui affiche le dialogue et qui renvoie le rsultat
var anArray  = displayDialog();
var strW     = anArray[0];
var strT     = anArray[1];
var distVal1 = anArray[2];
var distVal2 = anArray[3];
var numVal   = anArray[4];
var delVal   = anArray[5];
var dirDec   = anArray[6];

// les positions y1, x1, x2
var y1 = (Math.floor((gB[0]*1000)+0.5))/1000;
var x1 = (Math.floor((gB[1]*1000)+0.5))/1000;
var x2 = (Math.floor((gB[3]*1000)+0.5))/1000;
	
if (distVal1 == distVal2) {
	distVal = distVal1;
	// la moiti de la distance
	var halfDst = distVal/2;
	
	// comparer la largeur du bloc  la valeur de la distance
	if ((x2-x1) <= distVal) {
		alert ("Le bloc modle n'est pas assez large.\nLa largeur minimale = " + (distVal+0.1) + " mm", "Stop");
		reStoreSettings();
		exit();
	}
	
	// calculer le nombre des demi-cercles
	var nFrames = Math.ceil((x2-x1)/(distVal));
	
	// recalculer la valeur x2
	var x2 = x1+(nFrames*distVal);
	
	// la position y2
	var y2 = y1+(x2-x1);
	
	// comparer avec le nombre des quarts de cercle  supprimer
	if (delVal >= nFrames*2) {
		var maxVal = (nFrames*2)-1;
		alert ("Seulement " + maxVal + " quarts de cercle peuvent tre supprims.\n" + delVal + " est une valeur trop grande.", "Stop");
		reStoreSettings();
		exit();
	}
	
	// calculer le nombre de tours
	var nRounds = Math.ceil(nFrames/2);
	
	// le centre vertical de l'objet
	var m1 = y1 + (y2-y1);
		
	// prparer une liste
	var allFrames = new Array ();
	
	// crer un bloc circulaire...
	var baseOne = app.activeWindow.activePage.ovals.add();
	baseOne.properties = {geometricBounds:[y1, x1, y2, x2], fillColor:"None", strokeColor:"None"};
	// ... et l'ajouter  la liste
	allFrames.push(baseOne);
	
	// ouvrir le contour
	baseOne.paths[0].pathType = PathType.OPEN_PATH;
	
	// supprimer le premier point d'ancrage; le rsultat: un demi-cercle
	baseOne.paths[0].pathPoints[0].remove();
	
	// dupliquer le demi-cercle...
	var baseTwo = baseOne.duplicate(undefined, [0, y2-y1]);
	// ... et l'ajouter  la liste
	allFrames.push(baseTwo);
	
	// "symtrie axe horizontal" de la copie...
	baseTwo.flipItem(Flip.VERTICAL);
	
	// ... et la rduire
	var gB = baseTwo.geometricBounds; 
	baseTwo.geometricBounds = [gB[0], gB[1], gB[2]-halfDst, gB[3]-distVal];
	
	// dupliquer les demi-cercle de base dans une boucle et les rduire
	for (var n=0; n<nRounds-1; n++) {
	
		// dupliquer le premier demi-cercle...
		var newFrame = baseOne.duplicate([x1, y1]);
		// ... et l'ajouter  la liste
		allFrames.push(newFrame);
		
		// rduire la copie
		var gB = newFrame.geometricBounds; 
		newFrame.geometricBounds = [gB[0]+(distVal*(n+1)), gB[1]+distVal*(n+1), gB[2], gB[3]-distVal*(n+1)];
		
		try {
			// dupliquer le deuxime demi-cercle...
			var newFrame = baseTwo.duplicate([x1, m1-halfDst]);
			
			// rduire la copie
			var gB = newFrame.geometricBounds; 
			newFrame.geometricBounds = [gB[0], gB[1]+distVal*(n+1), gB[2]-(distVal*(n+1)), gB[3]-distVal*(n+1)];
			// ... et l'ajouter  la liste
			allFrames.push(newFrame);
		}
		catch (e) {
			newFrame.remove();
		}
	}
}
else {
	// vrifier si le bloc slectionn est assez large
	if (x2-x1<distVal1+distVal2+numVal) {
		alert ("Slectionner un bloc plus large, s.v.p.", "Stop");
		reStoreSettings();
		exit();
	}
	
	// prparer la chane de chiffres croissante entre la valeur de dpart et celle de la fin  l'aide de 'log' et 'exp'
	var d = ((Math.log(distVal1/distVal2))/numVal)*-1;
	var curDist = distVal1;
	var distSum = 0;
	var distArr = new Array ();
	// dfinir les valeurs dans une boucle
	for (var n=1; n<numVal-1; n++) {
		curDist = distVal2*(Math.exp(-d*n));
		curDist = (Math.round(curDist*1000))/1000;
		// additionner la valeur actuelle au total...
		distSum += curDist;
		// ... et l'ajouter  la liste
		distArr.push(curDist);
	}
	
	// dfinir la diffrence de la distance
	var distDif = x2-x1-distVal1-distVal2;
	// calculer le facteur
	var distFact = distSum/distDif;

	// intervertir la liste
	distArr.reverse();
	
	// prparer une nouvelle liste
	var defArr = new Array ();

	// une boucle  travers les valeurs afin de les adapter  la distance restante
	for (var n=0; n<distArr.length; n++) {
		tmpDist = Math.round((distArr[n]/distFact)*1000)/1000;
		defArr.push(tmpDist);
	}
	// insrer la premire et...
	defArr.unshift(distVal1);
	// ... la dernire valeur
	defArr.push(distVal2);

	// prparer encore une liste
	var allFrames = new Array ();
	
	// crer un bloc circulaire...
	var y2 = y1+(x2-x1);
	var baseOne = app.activeWindow.activePage.ovals.add();
	baseOne.properties = {geometricBounds:[y1, x1, y2, x2], fillColor:"None", strokeWeight:0, strokeColor:"None"};
	// ... et l'ajouter  la liste
	allFrames.push(baseOne);
	
	// ouvrir le contour
	baseOne.paths[0].pathType = PathType.OPEN_PATH;
	
	// supprimer le premier point d'ancrage; le rsultat: un demi-cercle
	baseOne.paths[0].pathPoints[0].remove();
	
	// le centre vertical de l'objet
	var gB = baseOne.geometricBounds;
	var m1 = Math.round(gB[2]*1000)/1000;
	
	// dupliquer le demi-cercle...
	var baseTwo = baseOne.duplicate(undefined, [0, y2-y1]);
	// ... et l'ajouter  la liste
	allFrames.push(baseTwo);
	
	// "symtrie axe horizontal" de la copie...
	baseTwo.flipItem(Flip.VERTICAL);
	
	// ... et la rduire
	var gB = baseTwo.geometricBounds; 
	baseTwo.geometricBounds = [gB[0], gB[1], gB[2]-(distVal1/2), gB[3]-distVal1];

	// appliquer  deux nouvelles variables les deux blocs de base
	var newFrameOne = baseOne;
	var newFrameTwo = baseTwo;

	// dupliquer les demi-cercles de base dans une boucle et les rduire
	for (var n=0; n<(numVal/2)-1; n++) {
	
		// dupliquer le premier demi-cercle...
		newFrameOne = newFrameOne.duplicate(undefined, [0, 0]);
		// ... et l'ajouter  la liste
		allFrames.push(newFrameOne);
		
		// rduire la copie
		var gB = newFrameOne.geometricBounds;
		var xt1 = gB[1]+defArr[(n*2)+1];
		var xt2 = gB[3]-defArr[n*2];
		var yt1 = m1-((xt2-xt1)/2);
		newFrameOne.geometricBounds = [yt1, xt1, m1, xt2];
		
		try {
			// dupliquer le deuxime demi-cercle...
			var newFrameTwo = newFrameTwo.duplicate(undefined, [0, 0]);

			// rduire la copie
			var gB = newFrameTwo.geometricBounds; 
			var xt1 = gB[1]+defArr[(n*2)+1];
			var xt2 = gB[3]-defArr[(n*2)+2];
			var yt2 = m1+((xt2-xt1)/2);
			newFrameTwo.geometricBounds = [m1, xt1, yt2, xt2];
			// ... et l'ajouter  la liste
			allFrames.push(newFrameTwo);
		}
		catch (e) {
			// supprimer le dernier bloc lors d'un problme
			newFrameTwo.remove();
			// et quitter la boucle
			break;
		}
	}
}

// joindre les points d'extrmit
for (var n=1; n<allFrames.length; n++) {
	if (n%2 == 0) {
		try {
			allFrames[0].paths[0].pathPoints[n*2].join(allFrames[n].paths[0].pathPoints[0], JoinOptions.COMBINE);
		}
		catch (e) {
		}
	}
	else {
		try {
			allFrames[0].paths[0].pathPoints[n*2].join(allFrames[n].paths[0].pathPoints[2], JoinOptions.COMBINE);
		}
		catch (e) {
		}
	}
}

// appliquer quelques attributs au contour
allFrames[0].properties = {strokeColor:"Black", strokeWeight:strW, strokeTint:strT, 
		strokeAlignment:StrokeAlignment.CENTER_ALIGNMENT, endCap:EndCap.ROUND_END_CAP};

// inverser la direction
allFrames[0].paths[0].reverse ();

// supprimer des quarts de cercle (si souhait)
if (delVal>0) {
	if (distVal1 != distVal2) {
		defVal = delVal+2;
	}
	else {
		defVal = delVal;
	}
	for (var d=0; d<defVal; d++) {
		allFrames[0].paths[0].pathPoints[0].remove();
	}
}

// "dans le sens des aiguilles d'une montre" (= par dfaut) ou "dans le sens inverse des aiguilles d'une montre"
if (dirDec == 0) {
	var dirTxt = "dans le sens des aiguilles d'une montre";
}
else if (dirDec == 1) {
	var dirTxt = "dans le sens inverse des aiguilles d'une montre";
	// slectionner le point de rfrence au milieu
	curDoc.layoutWindows[0].transformReferencePoint = AnchorPoint.centerAnchor;
	// "symtrie axe horizontal" de la spirale
	allFrames[0].flipItem(Flip.VERTICAL);
}

// entrer le rsultat dans l'tiquette
if (distVal1 != distVal2) {
	allFrames[0].label = " distance extrieure: " + distVal1 + " mm\r\n distance intrieure: " + distVal2 + " mm\r\n le nombre de demi-cercles: " + numVal + "\r\n supprim " + delVal + " quarts de cercle\r\n " + dirTxt;
}
else {
	allFrames[0].label = " distance des contours: " + distVal + " mm\r\n supprim " + delVal + " quarts de cercle\r\n " + dirTxt;
}

// appeler la fonction pour restaurer les rglages
reStoreSettings();


////////////////////////////// les fonctions //////////////////////////////////////////////////////

// la fonction qui renvoie les valeurs mmorises  ////////////////////////////////////////////////
function getPrefs() {
	var allPrefs = "";
	// lire le fichier qui contient les valeurs mmorises
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/SpiraleVariable501.txt");
	}
	else {
		var f = new File("~/Library/Preferences/SpiraleVariable501.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			allPrefs = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return allPrefs;
}

// prparer et afficher le dialogue ///////////////////////////////////////////////////////////////
function displayDialog() {
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	var labelWidth = 140;
	var fieldWidth =  36;
	var aDialog = app.dialogs.add({name:"SpiraleVariable"});
	with (aDialog) {
		with (dialogColumns.add()) {
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"L'paisseur du contour:", minWidth:labelWidth});
						var weightField = realEditboxes.add({editValue:strW, minimumValue:0.1, maximumValue:99, minWidth:fieldWidth});
						staticTexts.add({staticLabel:"pt", minWidth:12});
						staticTexts.add({staticLabel:"", minWidth:3});
					}
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"La teinte du contour:", minWidth:labelWidth});
						var tintField = realEditboxes.add({editValue:strT, minimumValue:1, maximumValue:100, minWidth:fieldWidth});
						staticTexts.add({staticLabel:"%", minWidth:12});
					}
				}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Distances des contours:"});
					}
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:" l'extrieur:", minWidth:labelWidth});
						var distOuterField = realEditboxes.add({editValue:dtV1, minWidth:fieldWidth});
						staticTexts.add({staticLabel:"mm", minWidth:12});
					}
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:" l'intrieur:", minWidth:labelWidth});
						var distInnerField = realEditboxes.add({editValue:dtV2, minWidth:fieldWidth});
						staticTexts.add({staticLabel:"mm", minWidth:12});
					}
				}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Nombre de demi-cercles:", minWidth:labelWidth});
						var numField = integerEditboxes.add({editValue:numV, minimumValue:0, maximumValue:9999, minWidth:fieldWidth});
						staticTexts.add({staticLabel:"", minWidth:21});
					}
				}
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Supprimer"});
				var delField = integerEditboxes.add({editValue:delV, minimumValue:0, maximumValue:9999, minWidth:fieldWidth, });
				staticTexts.add({staticLabel:"quarts de cercle  l'intrieur"});
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Le contour dans le sens...", minWidth:60});
						staticTexts.add({staticLabel:" ", minWidth:59});
					}
					with (dialogRows.add()) {
						with(dirButtons = radiobuttonGroups.add()){
							radiobuttonControls.add({staticLabel:"des aiguilles d'une montre", checkedState:ck01});
							radiobuttonControls.add({staticLabel:"inverse des aiguilles d'une montre", checkedState:ck02});
						}
					}
				}
			}
		}
	}
	if(aDialog.show() == true) {
		// relever la saisie
		var strWght  = weightField.editValue;
		var strTint  = tintField.editValue;
		var distVal1 = distOuterField.editValue;
		var distVal2 = distInnerField.editValue;
		var numVal   = numField.editValue;
		var delVal   = delField.editValue;
		var dirDec   = dirButtons.selectedButton;
		// supprimer le dialogue
		aDialog.destroy();
		if (distVal1 == 0 && distVal2 == 0) {
			alert ("Les deux valeurs \"distance\" sont zro.\nUn nouvel essai, s.v.p.", "Stop");
			reStoreSettings();
			exit();
		}
		else {
			if (distVal2 == 0) {
				distVal2 = distVal1;
			}
			else if (distVal1 == 0) {
				distVal1 = distVal2;
			}
		}
		// la nouvelle liste des prfrences
		var prefsList = new Array (strWght, strTint, distVal1, distVal2, numVal, delVal, dirDec);
		// la convertir en chane de texte
		var prefString = prefsList.join("\n");
		// l'envoyer  la fonction qui crit le rsultat dans un fichier
		writeResult(prefString);
		// vrifier le nombre des quarts de cercle  supprimer
		if (distVal1 != distVal2) {
			var maxVal = (numVal*2)-1;
			if (maxVal < delVal) {
				alert ("Seulement " + maxVal + " quarts de cercle peuvent tre supprims.\n" + delVal + " est une valeur trop grande.", "Stop");
				reStoreSettings();
				exit();
			}
		}
		// renvoyer le rsultat  l'appel de la fonction
		return [strWght, strTint, distVal1, distVal2, numVal, delVal, dirDec];
	}
	else{
		// lors d'un clic sur "Annuler": supprimer le dialogue...
		aDialog.destroy();
		// ... appeler la fonction pour restaurer les rglages...
		reStoreSettings();
		// ... et arrter l'excution
		exit();
	}
}

// crire le rsultat dans un fichier /////////////////////////////////////////////////////////////
function writeResult(curPrefs) {
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/SpiraleVariable501.txt");
	}
	else {
		var f = File("~/Library/Preferences/SpiraleVariable501.txt");
	}
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(curPrefs);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}

// restaurer les rglages modifis ////////////////////////////////////////////////////////////////
function reStoreSettings() {
	// les units de mesure, l'origine des rgles, le point zro et le point de rfrence
	curDoc.viewPreferences.horizontalMeasurementUnits = hM;
	curDoc.viewPreferences.verticalMeasurementUnits = vM;
	curDoc.viewPreferences.rulerOrigin = rO;
	curDoc.zeroPoint = zP;
	curDoc.layoutWindows[0].transformReferencePoint = tR;
}